"""
 UI module of coloring book.

 Sets up main loop and processes events.
"""

import coloring_book, pygame, sys
from locals import *

class UI:
	def __init__ ( self ):
		pygame.init ()
		pygame.display.set_caption ( DISPLAY_CAPTION )
		self.screen = pygame.display.set_mode ( DISPLAY_SIZE )
		self.clock = pygame.time.Clock ()
		self.cb = coloring_book.book ()
		self.messages = []

	def main ( self ):
		pygame.event.set_allowed ( None )
		pygame.event.set_allowed ( [ INIT, MESSAGE, QUIT, KEYDOWN, MOUSEBUTTONDOWN ] )
		event = pygame.event.Event ( INIT )
		while True:
			self.clock.tick ()
			self.iput ( event )
			self.game ( event )
			self.oput ( event )
			event = pygame.event.poll ()

	def oput ( self, event ):
		self.screen.blit ( self.cb.draw (), ( 0, 0 ) )
		if self.messages:
			messages = self.messages[:]
			for m in range ( 0, len ( messages ) ):
				pos = messages[m].position ()
				if pos:
					self.screen.blit ( messages[m].draw (), ( pos[0], pos[1] ) )
				else:
					del self.messages[m]
		pygame.display.update ()

	def iput ( self, event ):
		if event.type is KEYDOWN:
			if event.key == K_ESCAPE:
				pygame.event.post ( pygame.event.Event ( QUIT ) )
		elif event.type is MOUSEBUTTONDOWN:
			self.cb.check_click ( event.pos )

	def game ( self, event ):
		if event.type is QUIT:
			sys.exit ()
		elif event.type is MESSAGE:
			self.messages.append ( event.message )
